<script setup lang="ts">
import { toKebabCase } from '@/utils/toKebabCase';
import { Anchor, Chat } from 'slippers-ui/icons';
import type { BaseLink } from '@/types/base';
import GradientStarEyebrow from '~/assets/icons/gradient-star-eyebrow.vue';

interface Features {
  header: string;
  items: string[];
}
interface CardsProps {
  header: string;
  pill?: string;
  eyebrow: string;
  description: string;
  price: number;
  priceCta?: string;
  details: string[];
  button: BaseLink;
  featuresText: string;
  features: Features[];
  notes: string[];
  config?: { gradient: boolean };
}

defineProps<CardsProps>();
</script>

<template>
  <div class="pricing-card" :class="{ 'pricing-card--gradient': config?.gradient }">
    <div v-if="pill" class="pricing-card__pill">
      <GradientStarEyebrow class="slp-mr-4 img" />
      <SlpTypography variant="body2-bold" tag="span">
        {{ pill }}
      </SlpTypography>
    </div>
    <div :id="toKebabCase(header)">
      <SlpTypography variant="heading5-bold" tag="div">{{ eyebrow }}</SlpTypography>
      <SlpTypography variant="heading2-bold" tag="h3" class="slp-mb-16"
        >{{ header }}
        <a
          class="header-anchor"
          :href="`#${toKebabCase(header)}`"
          :aria-label="header"
          :data-ga-name="header.toLowerCase()"
          data-ga-location="body"
        >
          <SlpIcon :icon="Anchor" size="sm" /> </a
      ></SlpTypography>
    </div>
    <div>
      <SlpTypography variant="body2-bold" tag="p" class="slp-mb-16">{{ description }}</SlpTypography>
    </div>
    <div v-if="!!priceCta" class="pricing-card__price pricing-card__price--cta">
      <SlpIcon :icon="Chat" color="FFFFFF" size="lg" />
      <SlpTypography tag="p" variant="heading4-bold">{{ priceCta }}</SlpTypography>
    </div>
    <div v-else class="pricing-card__price">
      <SlpTypography tag="p" variant="heading2-bold">${{ price }}</SlpTypography>
      <div class="pricing-card__price__details">
        <SlpTypography v-for="line in details" :key="line" variant="body2-bold" tag="div">{{ line }} </SlpTypography>
      </div>
    </div>
    <SlpButton
      variant="primary"
      :href="button.config.href"
      :data-ga-location="button.config.dataGaLocation"
      :data-ga-name="button.config.dataGaName"
    >
      {{ button.text }}
    </SlpButton>
    <div>
      <SlpTypography variant="body2-bold" tag="p" class="slp-my-16">{{ featuresText }}</SlpTypography>
      <div v-for="feature in features" :key="feature.header">
        <SlpTypography variant="body2-bold" tag="p" class="slp-mb-16">{{ feature.header }}</SlpTypography>
        <ul class="pricing-card__features">
          <li v-for="item in feature.items" :key="item">
            <SlpTypography variant="body2" tag="span">
              {{ item }}
            </SlpTypography>
          </li>
        </ul>
      </div>
    </div>
    <div class="pricing-card__notes">
      <SlpTypography v-for="note in notes" :key="note" variant="body3" tag="p" class="slp-mb-16">
        {{ note }}
      </SlpTypography>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.pricing-card {
  height: 100%;
  padding: 48px;
  border-radius: 8px;
  background: $color-surface-50;
  color: $color-primary-200;
  &__pill {
    margin-bottom: 16px;
    position: relative;
    padding: 4px 12px;
    display: inline-flex;
    align-items: center;

    &::before {
      content: '';
      position: absolute;
      inset: 0;
      border-radius: 20px;
      border: 1.5px solid transparent;
      background: linear-gradient(89.09deg, #e1986d -1.12%, #7759c2 102.06%, #6e43d3 102.07%) border-box;
      -webkit-mask:
        linear-gradient(#fff 0 0) padding-box,
        linear-gradient(#fff 0 0);
      -webkit-mask-composite: xor;
      mask-composite: exclude;
    }

    .img {
      width: 15px;
      height: 16px;
    }
  }
  &__price {
    display: flex;
    align-items: center;
    gap: 16px;
    margin-bottom: 16px;

    &__details {
      display: flex;
      flex-direction: column;
      word-break: break-word;

      &:not(.gradient) {
        color: $color-text-link-100;
      }
    }

    &--cta {
      gap: 12px;
      margin-top: 10px;
      margin-bottom: 26px;

      .slp-text-heading4-bold {
        font-size: 1.75rem;
        font-weight: 580;
      }
    }
  }
  &__features {
    p {
      margin: 16px 0;
    }

    strong {
      font-weight: $font-weight-bold;
    }

    li {
      position: relative;
      padding-left: 24px;
      margin-bottom: 16px;
    }

    li::before {
      content: '';
      position: absolute;
      left: 0px;
      top: 8px;
      width: 12px;
      height: 10px;
      background: url("data:image/svg+xml,%3Csvg width='12' height='10' viewBox='0 0 12 10' fill='none' xmlns='http://www.w3.org/2000/svg'%3E%3Cpath d='M4.02879 9.03345C4.32771 9.03221 4.61416 8.91461 4.82639 8.70602L11.663 1.9316C11.7698 1.82664 11.8545 1.70177 11.9124 1.56418C11.9702 1.42659 12 1.27902 12 1.12997C12 0.980915 11.9702 0.833339 11.9124 0.695751C11.8545 0.558164 11.7698 0.433289 11.663 0.328327C11.4495 0.118037 11.1607 0 10.8597 0C10.5586 0 10.2698 0.118037 10.0564 0.328327L4.02879 6.32369L1.94364 4.25749C1.73015 4.0472 1.44136 3.92916 1.14034 3.92916C0.839318 3.92916 0.550528 4.0472 0.337042 4.25749C0.230245 4.36245 0.145479 4.48733 0.0876313 4.62491C0.029784 4.7625 0 4.91008 0 5.05913C0 5.20818 0.029784 5.35575 0.0876313 5.49334C0.145479 5.63093 0.230245 5.75581 0.337042 5.86077L3.21979 8.71731C3.43668 8.92453 3.72755 9.0382 4.02879 9.03345Z' fill='%237759C2'/%3E%3C/svg%3E");
      background-repeat: no-repeat;
      background-size: contain;
    }
  }
  &__notes {
    font-size: $text-body-3;
    line-height: $line-height-body-3;
    margin-top: 16px;
    color: $color-surface-500;
    font-style: italic;
  }
  .slp-btn {
    padding: 12px 48px;
  }
  .header-anchor {
    color: $color-text-300;
  }
  &--gradient {
    color: $color-text-50;
    background: linear-gradient(349.63deg, #291d42 4.85%, #3c2c31 95.5%);
    border-radius: 8px 8px 100px 8px;
    .pricing-card__notes {
      color: $color-surface-300;
    }
    .pricing-card__price__details {
      color: $color-text-50;
    }
    .slp-btn {
      background-color: #fff;
      border: none;
      color: $color-primary-200;
      &:hover,
      &:focus {
        background-color: $color-surface-200;
        border: none;
        outline: none;
      }
    }
    .header-anchor {
      color: #fff;
    }
  }
}
</style>
